9e6c4065fc56cad3db40a14e0a69414a256c0c03
   1#!/bin/sh
   2#
   3# This program resolves merge conflicts in git
   4#
   5# Copyright (c) 2006 Theodore Y. Ts'o
   6#
   7# This file is licensed under the GPL v2, or a later version
   8# at the discretion of Junio C Hamano.
   9#
  10
  11USAGE='[--tool=tool] [file to merge] ...'
  12SUBDIRECTORY_OK=Yes
  13OPTIONS_SPEC=
  14. git-sh-setup
  15require_work_tree
  16prefix=$(git rev-parse --show-prefix)
  17
  18# Returns true if the mode reflects a symlink
  19is_symlink () {
  20    test "$1" = 120000
  21}
  22
  23local_present () {
  24    test -n "$local_mode"
  25}
  26
  27remote_present () {
  28    test -n "$remote_mode"
  29}
  30
  31base_present () {
  32    test -n "$base_mode"
  33}
  34
  35cleanup_temp_files () {
  36    if test "$1" = --save-backup ; then
  37        mv -- "$BACKUP" "$path.orig"
  38        rm -f -- "$LOCAL" "$REMOTE" "$BASE"
  39    else
  40        rm -f -- "$LOCAL" "$REMOTE" "$BASE" "$BACKUP"
  41    fi
  42}
  43
  44describe_file () {
  45    mode="$1"
  46    branch="$2"
  47    file="$3"
  48
  49    printf "  {%s}: " "$branch"
  50    if test -z "$mode"; then
  51        echo "deleted"
  52    elif is_symlink "$mode" ; then
  53        echo "a symbolic link -> '$(cat "$file")'"
  54    else
  55        if base_present; then
  56            echo "modified"
  57        else
  58            echo "created"
  59        fi
  60    fi
  61}
  62
  63
  64resolve_symlink_merge () {
  65    while true; do
  66        printf "Use (l)ocal or (r)emote, or (a)bort? "
  67        read ans
  68        case "$ans" in
  69            [lL]*)
  70                git checkout-index -f --stage=2 -- "$path"
  71                git add -- "$path"
  72                cleanup_temp_files --save-backup
  73                return
  74                ;;
  75            [rR]*)
  76                git checkout-index -f --stage=3 -- "$path"
  77                git add -- "$path"
  78                cleanup_temp_files --save-backup
  79                return
  80                ;;
  81            [aA]*)
  82                exit 1
  83                ;;
  84            esac
  85        done
  86}
  87
  88resolve_deleted_merge () {
  89    while true; do
  90        if base_present; then
  91            printf "Use (m)odified or (d)eleted file, or (a)bort? "
  92        else
  93            printf "Use (c)reated or (d)eleted file, or (a)bort? "
  94        fi
  95        read ans
  96        case "$ans" in
  97            [mMcC]*)
  98                git add -- "$path"
  99                cleanup_temp_files --save-backup
 100                return
 101                ;;
 102            [dD]*)
 103                git rm -- "$path" > /dev/null
 104                cleanup_temp_files
 105                return
 106                ;;
 107            [aA]*)
 108                exit 1
 109                ;;
 110            esac
 111        done
 112}
 113
 114check_unchanged () {
 115    if test "$path" -nt "$BACKUP" ; then
 116        status=0;
 117    else
 118        while true; do
 119            echo "$path seems unchanged."
 120            printf "Was the merge successful? [y/n] "
 121            read answer < /dev/tty
 122            case "$answer" in
 123                y*|Y*) status=0; break ;;
 124                n*|N*) status=1; break ;;
 125            esac
 126        done
 127    fi
 128}
 129
 130merge_file () {
 131    path="$1"
 132
 133    f=`git ls-files -u -- "$path"`
 134    if test -z "$f" ; then
 135        if test ! -f "$path" ; then
 136            echo "$path: file not found"
 137        else
 138            echo "$path: file does not need merging"
 139        fi
 140        exit 1
 141    fi
 142
 143    ext="$$$(expr "$path" : '.*\(\.[^/]*\)$')"
 144    BACKUP="$path.BACKUP.$ext"
 145    LOCAL="$path.LOCAL.$ext"
 146    REMOTE="$path.REMOTE.$ext"
 147    BASE="$path.BASE.$ext"
 148
 149    mv -- "$path" "$BACKUP"
 150    cp -- "$BACKUP" "$path"
 151
 152    base_mode=`git ls-files -u -- "$path" | awk '{if ($3==1) print $1;}'`
 153    local_mode=`git ls-files -u -- "$path" | awk '{if ($3==2) print $1;}'`
 154    remote_mode=`git ls-files -u -- "$path" | awk '{if ($3==3) print $1;}'`
 155
 156    base_present   && git cat-file blob ":1:$prefix$path" >"$BASE" 2>/dev/null
 157    local_present  && git cat-file blob ":2:$prefix$path" >"$LOCAL" 2>/dev/null
 158    remote_present && git cat-file blob ":3:$prefix$path" >"$REMOTE" 2>/dev/null
 159
 160    if test -z "$local_mode" -o -z "$remote_mode"; then
 161        echo "Deleted merge conflict for '$path':"
 162        describe_file "$local_mode" "local" "$LOCAL"
 163        describe_file "$remote_mode" "remote" "$REMOTE"
 164        resolve_deleted_merge
 165        return
 166    fi
 167
 168    if is_symlink "$local_mode" || is_symlink "$remote_mode"; then
 169        echo "Symbolic link merge conflict for '$path':"
 170        describe_file "$local_mode" "local" "$LOCAL"
 171        describe_file "$remote_mode" "remote" "$REMOTE"
 172        resolve_symlink_merge
 173        return
 174    fi
 175
 176    echo "Normal merge conflict for '$path':"
 177    describe_file "$local_mode" "local" "$LOCAL"
 178    describe_file "$remote_mode" "remote" "$REMOTE"
 179    printf "Hit return to start merge resolution tool (%s): " "$merge_tool"
 180    read ans
 181
 182    case "$merge_tool" in
 183        kdiff3)
 184            if base_present ; then
 185                ("$merge_tool_path" --auto --L1 "$path (Base)" --L2 "$path (Local)" --L3 "$path (Remote)" \
 186                    -o "$path" -- "$BASE" "$LOCAL" "$REMOTE" > /dev/null 2>&1)
 187            else
 188                ("$merge_tool_path" --auto --L1 "$path (Local)" --L2 "$path (Remote)" \
 189                    -o "$path" -- "$LOCAL" "$REMOTE" > /dev/null 2>&1)
 190            fi
 191            status=$?
 192            ;;
 193        tkdiff)
 194            if base_present ; then
 195                "$merge_tool_path" -a "$BASE" -o "$path" -- "$LOCAL" "$REMOTE"
 196            else
 197                "$merge_tool_path" -o "$path" -- "$LOCAL" "$REMOTE"
 198            fi
 199            status=$?
 200            ;;
 201        meld|vimdiff)
 202            touch "$BACKUP"
 203            "$merge_tool_path" -- "$LOCAL" "$path" "$REMOTE"
 204            check_unchanged
 205            ;;
 206        gvimdiff)
 207            touch "$BACKUP"
 208            "$merge_tool_path" -f -- "$LOCAL" "$path" "$REMOTE"
 209            check_unchanged
 210            ;;
 211        xxdiff)
 212            touch "$BACKUP"
 213            if base_present ; then
 214                "$merge_tool_path" -X --show-merged-pane \
 215                    -R 'Accel.SaveAsMerged: "Ctrl-S"' \
 216                    -R 'Accel.Search: "Ctrl+F"' \
 217                    -R 'Accel.SearchForward: "Ctrl-G"' \
 218                    --merged-file "$path" -- "$LOCAL" "$BASE" "$REMOTE"
 219            else
 220                "$merge_tool_path" -X --show-merged-pane \
 221                    -R 'Accel.SaveAsMerged: "Ctrl-S"' \
 222                    -R 'Accel.Search: "Ctrl+F"' \
 223                    -R 'Accel.SearchForward: "Ctrl-G"' \
 224                    --merged-file "$path" -- "$LOCAL" "$REMOTE"
 225            fi
 226            check_unchanged
 227            ;;
 228        opendiff)
 229            touch "$BACKUP"
 230            if base_present; then
 231                "$merge_tool_path" "$LOCAL" "$REMOTE" -ancestor "$BASE" -merge "$path" | cat
 232            else
 233                "$merge_tool_path" "$LOCAL" "$REMOTE" -merge "$path" | cat
 234            fi
 235            check_unchanged
 236            ;;
 237        ecmerge)
 238            touch "$BACKUP"
 239            if base_present; then
 240                "$merge_tool_path" "$BASE" "$LOCAL" "$REMOTE" --mode=merge3 --to="$path"
 241            else
 242                "$merge_tool_path" "$LOCAL" "$REMOTE" --mode=merge2 --to="$path"
 243            fi
 244            check_unchanged
 245            ;;
 246        emerge)
 247            if base_present ; then
 248                "$merge_tool_path" -f emerge-files-with-ancestor-command "$LOCAL" "$REMOTE" "$BASE" "$(basename "$path")"
 249            else
 250                "$merge_tool_path" -f emerge-files-command "$LOCAL" "$REMOTE" "$(basename "$path")"
 251            fi
 252            status=$?
 253            ;;
 254    esac
 255    if test "$status" -ne 0; then
 256        echo "merge of $path failed" 1>&2
 257        mv -- "$BACKUP" "$path"
 258        exit 1
 259    fi
 260
 261    if test "$merge_keep_backup" = "true"; then
 262        mv -- "$BACKUP" "$path.orig"
 263    else
 264        rm -- "$BACKUP"
 265    fi
 266
 267    git add -- "$path"
 268    cleanup_temp_files
 269}
 270
 271while test $# != 0
 272do
 273    case "$1" in
 274        -t|--tool*)
 275            case "$#,$1" in
 276                *,*=*)
 277                    merge_tool=`expr "z$1" : 'z-[^=]*=\(.*\)'`
 278                    ;;
 279                1,*)
 280                    usage ;;
 281                *)
 282                    merge_tool="$2"
 283                    shift ;;
 284            esac
 285            ;;
 286        --)
 287            break
 288            ;;
 289        -*)
 290            usage
 291            ;;
 292        *)
 293            break
 294            ;;
 295    esac
 296    shift
 297done
 298
 299valid_tool() {
 300        case "$1" in
 301                kdiff3 | tkdiff | xxdiff | meld | opendiff | emerge | vimdiff | gvimdiff | ecmerge)
 302                        ;; # happy
 303                *)
 304                        return 1
 305                        ;;
 306        esac
 307}
 308
 309init_merge_tool_path() {
 310        merge_tool_path=`git config mergetool.$1.path`
 311        if test -z "$merge_tool_path" ; then
 312                case "$1" in
 313                        emerge)
 314                                merge_tool_path=emacs
 315                                ;;
 316                        *)
 317                                merge_tool_path=$1
 318                                ;;
 319                esac
 320        fi
 321}
 322
 323
 324if test -z "$merge_tool"; then
 325    merge_tool=`git config merge.tool`
 326    if test -n "$merge_tool" && ! valid_tool "$merge_tool"; then
 327            echo >&2 "git config option merge.tool set to unknown tool: $merge_tool"
 328            echo >&2 "Resetting to default..."
 329            unset merge_tool
 330    fi
 331fi
 332
 333if test -z "$merge_tool" ; then
 334    if test -n "$DISPLAY"; then
 335        merge_tool_candidates="kdiff3 tkdiff xxdiff meld gvimdiff"
 336        if test -n "$GNOME_DESKTOP_SESSION_ID" ; then
 337            merge_tool_candidates="meld $merge_tool_candidates"
 338        fi
 339        if test "$KDE_FULL_SESSION" = "true"; then
 340            merge_tool_candidates="kdiff3 $merge_tool_candidates"
 341        fi
 342    fi
 343    if echo "${VISUAL:-$EDITOR}" | grep 'emacs' > /dev/null 2>&1; then
 344        merge_tool_candidates="$merge_tool_candidates emerge"
 345    fi
 346    if echo "${VISUAL:-$EDITOR}" | grep 'vim' > /dev/null 2>&1; then
 347        merge_tool_candidates="$merge_tool_candidates vimdiff"
 348    fi
 349    merge_tool_candidates="$merge_tool_candidates opendiff emerge vimdiff"
 350    echo "merge tool candidates: $merge_tool_candidates"
 351    for i in $merge_tool_candidates; do
 352        init_merge_tool_path $i
 353        if type "$merge_tool_path" > /dev/null 2>&1; then
 354            merge_tool=$i
 355            break
 356        fi
 357    done
 358    if test -z "$merge_tool" ; then
 359        echo "No known merge resolution program available."
 360        exit 1
 361    fi
 362else
 363    if ! valid_tool "$merge_tool"; then
 364        echo >&2 "Unknown merge_tool $merge_tool"
 365        exit 1
 366    fi
 367
 368    init_merge_tool_path "$merge_tool"
 369
 370    merge_keep_backup="$(git config --bool merge.keepBackup || echo true)"
 371
 372    if ! type "$merge_tool_path" > /dev/null 2>&1; then
 373        echo "The merge tool $merge_tool is not available as '$merge_tool_path'"
 374        exit 1
 375    fi
 376fi
 377
 378
 379if test $# -eq 0 ; then
 380        files=`git ls-files -u | sed -e 's/^[^  ]*      //' | sort -u`
 381        if test -z "$files" ; then
 382                echo "No files need merging"
 383                exit 0
 384        fi
 385        echo Merging the files: "$files"
 386        git ls-files -u |
 387        sed -e 's/^[^   ]*      //' |
 388        sort -u |
 389        while IFS= read i
 390        do
 391                printf "\n"
 392                merge_file "$i" < /dev/tty > /dev/tty
 393        done
 394else
 395        while test $# -gt 0; do
 396                printf "\n"
 397                merge_file "$1"
 398                shift
 399        done
 400fi
 401exit 0